#ifndef __GLADOS_H__
# define __GLADOS_H__		1

/* Screen size. */
#define __SCREEN_WIDTH	128
#define __SCREEN_HEIGHT	64

/* Ascii size. */
#define __ASCII_WIDTH	4
#define __ASCII_HEIGHT	6

/* Standard stream info. */
#define __NB_STREAM 	3
#define __STDIN 	0
#define __STDOUT 	1
#define __STDERR 	2
#define __STD_WIDTH	__SCREEN_WIDTH / __ASCII_WIDTH
#define __STD_HEIGHT 	(__SCREEN_HEIGHT / __ASCII_HEIGHT) - 1

/* Define stack size for all stream. */
#ifndef __STD_STACK
# define __STD_STACK	24
#endif

/* Define types. */
#include <stdint.h>
#include <stddef.h>
#include "lib/my_stddef.h"

typedef struct glados_s
{
	size_t id;
	uint8_t *vram;
	int cursor[__NB_STREAM];
	uint8_t output[__NB_STREAM][__STD_STACK + 1][__STD_WIDTH + 1];
} glados_t;

#endif /* __GLADOS_H__ */
