#ifndef __SYSCALL_H__
# define __SYSCALL_H__

/* Define `size_t` type. */
#include <stddef.h>
#include "lib/my_stddef.h"

/* Casio's info / syscall */
void __free(void *ptr);
void *__malloc(size_t size);
void *__get_vram(void);
void __get_osinfo(unsigned char *main_version, unsigned char *minor_version,
unsigned short *release, unsigned short *build);

/* Interrupt syscall */
void *__get_vbr(void);
void __block_interrupt(void);
void __set_vbr(void *new_vbr);
void __unblock_interrupt(void);

#endif /* __SYSCALL_H__ */
