#include <stdint.h>

extern int main(void);
extern void __save_stuff(void);
extern void __restore_stuff(void);
extern void init_glados(void);
extern void quit_glados(void);

extern uint32_t bbss_ram;
extern uint32_t bbss_rom;
extern uint32_t bss_size;
extern uint32_t bdata_ram;
extern uint32_t bdata_rom;
extern uint32_t data_size;
extern uint32_t bglados_ram;
extern uint32_t bglados_rom;
extern uint32_t glados_size;


__attribute__((section(".pretext.dump"))) int section_dump(void *bsection_ram,
void *bsection_rom, int32_t section_size_dump)
{
	uint32_t *ram_section = (uint32_t*)bsection_ram;
	uint32_t *rom_section = (uint32_t*)bsection_rom;
	int i;

	i = -1;
	while (++i < section_size_dump >> 2)
		ram_section[i] = rom_section[i];
}

__attribute__((section(".pretext.dump"))) void section_reset
(void *bsection_start, int32_t section_size)
{
	uint32_t *rom_start;
	int i;
       	
	
	i = -1;
	rom_start = (uint32_t*)bsection_start;
	while (++i < section_size >> 2)
		rom_start[i] = 0;
}

__attribute__((section(".pretext"))) int bootstrap(void)
{
	int exit;
	
	section_reset(&bbss_rom, (int32_t)&bss_size);
	section_dump(&bdata_ram, &bdata_rom,
	(int32_t)((uint32_t)&bdata_rom - (uint32_t)&data_size));
	section_dump(&bglados_ram, &bglados_rom,
	(int32_t)((uint32_t)&bglados_rom - (uint32_t)&glados_size));
	init_glados();
	__save_stuff();
	exit = main();
//	__restore_stuff();
	quit_glados();
	return (0);
}
