OUTPUT_ARCH(sh3)
ENTRY(_bootstrap)

MEMORY
{
	rom	: o = 0x00300200, l = 512k
	ram	: o = 0x08100000, l = 8k
	my_ram	: o = 0x8800d000, l = 12k
}

SECTIONS
{
	.text	: ALIGN(4) {
		*(.pretext)
		*(.pretext.*)
		*(.text)
		*(.text.*)
	} > rom
	.rodata	: ALIGN(4) {
		*(.rodata)
		*(.rodata.*)
		_erodata = . ;
	} > rom



	.bss	: ALIGN(4) {
		*(.bss)
		*(.bss.*)
		*(COMMON)
		_bss_size = SIZEOF(.bss) ;
		_bbss_rom = LOADADDR(.bss) ;
	} > ram
	.data	: AT(_erodata + SIZEOF(.bss)) ALIGN (4){
		_bdata_ram = . ;
		*(.data)
		*(.data.*)
		. = ALIGN(4) ;
		_data_size = LOADADDR(.data) + SIZEOF(.data) ;
		_bdata_rom = LOADADDR(.data) ;
	} > ram


/*
 * RAM section witch set my interupt handler.
 * vbr + 0x100 -> exeption interupt.
 * vbr + 0x400 -> tlb miss.
 * vbr + 0x600 -> other interupt.
*/
 
	.glados	: AT(_erodata + SIZEOF(.bss) + SIZEOF(.data)) ALIGN(4) {
		. = ALIGN(0x100) ;
		_glados_vbr = . ;
		_bglados_ram = . ;
		. = _glados_vbr + 0x100 ;
		*(.glados.exept)
		. = _glados_vbr + 0x400 ;
		*(.glados.tlb)
		. = _glados_vbr + 0x600 ;
		*(.glados.interupt)
		. = ALIGN(4) ;
		_glados_size = LOADADDR(.glados) + SIZEOF(.glados) ;
		_bglados_rom = LOADADDR(.glados) ;
	} > my_ram




	.eh_frame : AT (_erodata + SIZEOF(.bss) + SIZEOF(.data) + SIZEOF(.glados)) ALIGN(4) {
		*(.eh_frame)
		*(.eh_frame.*)
	} > rom
}
