#include "glados/7305.h"
#include "glados/stream.h"
#include "glados/syscall.h"
#include "glados/screen.h"
#include "lib/my_stdio.h"
#include "lib/my_unistd.h"

extern void put_nbr(int x, int y, uint32_t data, int pos);
volatile uint32_t interrupt_counter;
extern uint32_t glados_vbr;
extern glados_t *glados;

__attribute__((section(".glados.exept"), interrupt_handler))
void exeption_handler(void)
{
	while (1);
}

__attribute__((section(".glados.tlb"), interrupt_handler))
void tlb_handler(void)
{
	while (1);
}

__attribute__((section(".glados.interupt"), interrupt_handler))
void interrupt_handler(void)
{
	while (1);
}

#ifdef INTERRUPT_DEBUG
static void stop_interrupt(void)
{
	INTC.IPRA.WORD = 0x0000;
	INTC.IPRB.WORD = 0x0000;
	INTC.IPRC.WORD = 0x0000;
	INTC.IPRD.WORD = 0x0000;
	INTC.IPRE.WORD = 0x0000;
	INTC.IPRF.WORD = 0x0000;
	INTC.IPRG.WORD = 0x0000;
	INTC.IPRH.WORD = 0x0000;
	INTC.IPRI.WORD = 0x0000;
	INTC.IPRJ.WORD = 0x0000;
	INTC.IPRK.WORD = 0x0000;
	INTC.IPRL.WORD = 0x0000;
}

static void dump_intc(void)
{
	/*
	my_printf("IPRA: %#x\n", INTC.IPRA.WORD);
	my_printf("IPRB: %#x\n", INTC.IPRB.WORD);
	my_printf("IPRC: %#x\n", INTC.IPRC.WORD);
	my_printf("IPRD: %#x\n", INTC.IPRD.WORD);
	my_printf("IPRE: %#x\n", INTC.IPRE.WORD);
	my_printf("IPRF: %#x\n", INTC.IPRF.WORD);
	my_printf("IPRG: %#x\n", INTC.IPRG.WORD);
	my_printf("IPRH: %#x\n", INTC.IPRH.WORD);
	my_printf("IPRI: %#x\n", INTC.IPRI.WORD);
	my_printf("IPRJ: %#x\n", INTC.IPRJ.WORD);
	my_printf("IPRK: %#x\n", INTC.IPRK.WORD);
	my_printf("IPRL: %#x\n", INTC.IPRL.WORD);
	*/
	my_printf("IPRA: %#x\n", (uint32_t)&(INTC.IPRA));
	my_printf("IPRB: %#x\n", (uint32_t)&(INTC.IPRB));
	my_printf("IPRC: %#x\n", (uint32_t)&(INTC.IPRC));
	my_printf("IPRD: %#x\n", (uint32_t)&(INTC.IPRD));
	my_printf("IPRE: %#x\n", (uint32_t)&(INTC.IPRE));
	my_printf("IPRF: %#x\n", (uint32_t)&(INTC.IPRF));
	my_printf("IPRG: %#x\n", (uint32_t)&(INTC.IPRG));
	my_printf("IPRH: %#x\n", (uint32_t)&(INTC.IPRH));
	my_printf("IPRI: %#x\n", (uint32_t)&(INTC.IPRI));
	my_printf("IPRJ: %#x\n", (uint32_t)&(INTC.IPRJ));
	my_printf("IPRK: %#x\n", (uint32_t)&(INTC.IPRK));
	my_printf("IPRL: %#x\n", (uint32_t)&(INTC.IPRL));

}

void show_interrupt_counter(void)
{
	puts("stop interrupt...");
	__block_interrupt();
	puts("DONE\nDump INTC:\n");
	dump_intc();
/*	puts("reset interrupt...");
	stop_interrupt();
	puts("DONE\n");
	interrupt_counter = 0;
	puts("set new VBR...");
	__set_vbr((void*)&glados_vbr);
	puts("DONE\nAllow interrupt...");
	__unblock_interrupt();
	puts("DONE\n");
	//ICRX.ICR0.MAI = 1;
	my_printf("ICR0: %#x\n", (uint32_t)&(ICRX.ICR0));
	my_printf("ICR1: %#x\n", (uint32_t)&(ICRX.ICR1));*/
	while (1);
	while (1){
		__clear_vram(glados->vram);
		put_nbr(0, 0, interrupt_counter, 0);
		__display_vram(glados->vram);
	}
}
#endif
