#include "lib/my_stdlib.h"
#include "lib/my_string.h"
#include "glados/syscall.h"
#include "glados/screen.h"
#include "glados/stream.h"

extern glados_t *glados;

/* TODO: hard code __put_pixel_VRAM in asm */
static void __put_pixel_VRAM(int x, int y, size_t color)
{
	if (x & ~127 || y & ~63)
		return;
	if (color)
		glados->vram[(y << 4) + (x >> 3)] |= 0x80 >> (x & 0x07);
	else
		glados->vram[(y << 4) + (x >> 3)] &= ~(0x80 >> (x & 0x07));
}

/* TODO: hard code __set_ascii_VRAM in asm */
static void __set_ASCII_VRAM(int x, int y, uint8_t n)
{
	unsigned short buffer;
	int i;
	int j;

	i = -1;
	buffer = Font1[n];
	while (++i < 4){
		j = -1;
		while (++j < 5){
			__put_pixel_VRAM(x + i, y + 4 - j,
			buffer & 0x01);
			buffer >>= 1;
		}
	}
}

void put_nbr(int x, int y, uint32_t data, int pos)
{
	const uint8_t hexa[] = "0123456789abcdef";
	if (pos == 8)
		return;
	put_nbr(x, y, data >> 4, pos + 1);
	__set_ASCII_VRAM(x + ((8 - pos) * __ASCII_WIDTH), y, hexa[data & 0x0f]);
}

void display_stream(void)
{
	int i;
	int j;

	 i = -1;
	__clear_vram(glados->vram);
	while (++i <= glados->cursor[__STDOUT]){
		j = 0;
		while (glados->output[__STDOUT][i][j] != '\0' &&
		glados->output[__STDOUT][i][j] != '\n'){
			__set_ASCII_VRAM(j * __ASCII_WIDTH, i *
			__ASCII_HEIGHT, glados->output[__STDOUT][i][j++]);
		}
	}
	__display_vram(glados->vram);
}
