.global ___free
.global ___malloc
.global ___get_vbr
.global ___set_vbr
.global ___get_vram
.global ___get_osinfo
.global ___block_interrupt
.global ___unblock_interrupt

___free:
	mov.l	syscall_tab, r1
	mov.l	syscall_free, r0
	jmp	@r1
	nop
	rts
	nop

___malloc:
	mov.l	syscall_tab, r1
	mov.l	syscall_malloc, r0
	jmp	@r1
	nop
	rts
	nop

___get_vram:
	mov.l	syscall_tab, r1
	mov.l	syscall_get_vram, r0
	jmp	@r1
	nop
	rts
	nop

___get_osinfo:
	mov.l	syscall_tab, r1
	mov.l	syscall_get_osinfo, r0
	jmp	@r1
	nop
	rts
	nop

___get_vbr:
	rts
	stc vbr, r0

___set_vbr:
	rts
	ldc	r4, vbr

___block_interrupt:
	mov.l 	sr_pause, r0
	stc	sr, r3
	or 	r0, r3
	ldc	r3, sr
	rts
	nop

___unblock_interrupt:
	mov.l	sr_pause, r0
	not	r0, r0
	stc	sr, r3
	and	r0, r3
	ldc	r3, sr
	rts
	nop

	

.align 4
sr_pause:		.long 1 << 28
syscall_tab:		.long 0x80010070
syscall_free:		.long 0x00000acc
syscall_malloc:		.long 0x00000acd
syscall_get_vram:	.long 0x00000135
syscall_get_osinfo:	.long 0x00000015
.end
